#property copyright "Scriptong"
#property link "http://autograf.dp.ua"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DeepSkyBlue

#property indicator_level1 0.0

extern int accelerationPeriod = 30;
extern int accelerationPrice  = PRICE_TYPICAL;

double maBuffer[];
double accuracy;

//+-------------------------------------------------------------------------------------+
//| Custom indicator initialization function                                            |
//+-------------------------------------------------------------------------------------+
int init()
{
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, maBuffer);

   if (accelerationPeriod < 2)
   {
      Alert("  accelerationPeriod.   30.");
      accelerationPeriod = 30;
   } 
   
   if (accelerationPrice < PRICE_CLOSE || accelerationPrice > PRICE_WEIGHTED)
   {
      Alert("   .     (5)");
      accelerationPrice = PRICE_TYPICAL;
   }

   accuracy = Point/100.0;                         //   

   return(0);
}
//+-------------------------------------------------------------------------------------+
//|   ,                   |
//+-------------------------------------------------------------------------------------+
int GetRecalcIndex()
{
   int counted_bars = IndicatorCounted();
   if (counted_bars>0) counted_bars--;
   return(MathMin(Bars - counted_bars, Bars - 2));
}
//+-------------------------------------------------------------------------------------+
//|                                                      |
//+-------------------------------------------------------------------------------------+
double GetPrice(int i)
{
   switch (accelerationPrice)
   {
      case PRICE_CLOSE:    return(Close[i]);
      case PRICE_OPEN:     return(Open[i]);
      case PRICE_HIGH:     return(High[i]);
      case PRICE_LOW:      return(Low[i]);
      case PRICE_MEDIAN:   return((High[i] + Low[i])/2);
      case PRICE_TYPICAL:  return((High[i] + Low[i] + Close[i])/3);
      case PRICE_WEIGHTED: return((High[i] + Low[i] + 2*Close[i])/4);
   }
}
//+-------------------------------------------------------------------------------------+
//|                                                                  |
//+-------------------------------------------------------------------------------------+
void Acceleration(int index)
{
   double mul = 2.0/(accelerationPeriod + 1);      //   

   if (index == Bars - 2)                          //    ..
      maBuffer[index+1] = (GetPrice(index+1) -     // ..  ,  ..
                           GetPrice(index+2))/accuracy;// ..  
                                                   // ..
   for (int i = index; i >= 0; i--)                //    
      maBuffer[i] = (GetPrice(i) - GetPrice(i+1))*mul/accuracy +
                    maBuffer[i+1]*(1 - mul);
}
//+-------------------------------------------------------------------------------------+
//| Custom indicator iteration function                                                 |
//+-------------------------------------------------------------------------------------+
int start()
{
   int limit = GetRecalcIndex();                   //    
   Acceleration(limit);                            //  

   return(0);
}

